unit UGoal2DRaced;

interface

uses UGoal, UPlayer2D;

type TGoal2DRaced = class(TGoal)
  private
  protected
  public
    constructor create(c: double); override;
    procedure CalcScore(FireAt: TGoalFire); override;
  end;


implementation

uses Math;


constructor TGoal2dRaced.create(c: double);
begin
  inherited;
  fDisplayName:= 'Love speeding';
end;

procedure TGoal2dRaced.CalcScore(FireAt: TGoalFire);
var
  p: TPlayer2D;
begin
  inherited;
  p:= TPlayer2D(Player);
  // Add Euclidean distance, using "Player.Size" as the unit:
  if (FireAt = gfStep) then begin
    Score:= Sqrt(Sqr(p.PosX-p.OldPosX) + Sqr(p.PosY-p.OldPosY)) / p.Size;
  end else begin
    // If "raced" were a param I could calc. it here.
  end;
end;


end.
