unit UFormTest2D;

interface

uses
  // Delphi includes:
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DateUtils, Math, StdCtrls, Buttons, ComCtrls, ExtDlgs,
  Menus, AppEvnts,
  // Project includes:
  UTrack2D, UTeam, UPlayer2D, UKart, URocket;

type
  TFormTest2D = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Loadcircuit800x600BMP1: TMenuItem;
    Saveimagestofolder: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    SaveDialog: TSaveDialog;
    Graphicdebuglevels1: TMenuItem;
    MenuDebugTraces: TMenuItem;
    MenuDebugOptions: TMenuItem;
    Panel3: TPanel;
    PanelImg: TPanel;
    ImgRoad: TImage;
    Panel4: TPanel;
    GroupBox3: TGroupBox;
    StartBtn: TSpeedButton;
    PauseBtn: TSpeedButton;
    EdTrackParams: TGroupBox;
    Label5: TLabel;
    Label8: TLabel;
    LbFriction: TLabel;
    LbSideFriction: TLabel;
    EdPlayerParams: TGroupBox;
    EdHandMove: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    LbRadio: TLabel;
    EdFriction: TTrackBar;
    EdSideFriction: TTrackBar;
    EdRadio: TTrackBar;
    edChoosePlayer: TGroupBox;
    EdColor: TPanel;
    EdPlayerId: TComboBox;
    ColorDialog: TColorDialog;
    BtnAddPlayer: TSpeedButton;
    EdAutoRadio: TCheckBox;
    BtnReset: TSpeedButton;
    BtnSubPlayer: TSpeedButton;
    EdCollisions: TCheckBox;
    Label9: TLabel;
    EdAI_Level: TComboBox;
    Addaformation1: TMenuItem;
    Addacircleofkarts1: TMenuItem;
    MenuDebugGoals: TMenuItem;
    MenuDebugTeamGoals: TMenuItem;
    Addateamgoalforcollectingdrops1: TMenuItem;
    Addateamgoalforstoringcollecteddrops1: TMenuItem;
    AvoidOtherPlayers: TMenuItem;
    Label3: TLabel;
    LbSize: TLabel;
    EdSize: TTrackBar;
    SpeedButton7: TSpeedButton;
    Addagoal1: TMenuItem;
    N2: TMenuItem;
    DeleteallTeamsGoals1: TMenuItem;
    SpeedButton8: TSpeedButton;
    PanelView1: TMenuItem;
    menuChoosePlayer: TMenuItem;
    menuPlayerParams: TMenuItem;
    MenuTrackParams: TMenuItem;
    menuHandMove: TMenuItem;
    EdGoals: TGroupBox;
    menuGoals: TMenuItem;
    Runfast1: TMenuItem;
    Keepenergyhunger1: TMenuItem;
    Deleteallplayerspersonalgoals1: TMenuItem;
    SpeedButton9: TSpeedButton;
    PopupGoalParam: TPopupMenu;
    menuBetterSooner: TMenuItem;
    EdAIParams: TGroupBox;
    LbSeconds: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    LbMinFutures: TLabel;
    EdSeconds: TTrackBar;
    EdMinFutures: TTrackBar;
    N1: TMenuItem;
    N3: TMenuItem;
    menuBasicAIparams: TMenuItem;
    N4: TMenuItem;
    menuIndividual: TMenuItem;
    menuCooperative: TMenuItem;
    menuCompetitive: TMenuItem;
    MenuDebugLevels: TMenuItem;
    Keephealth1: TMenuItem;
    Suckenergyfromplayersinfrontofyou1: TMenuItem;
    FollowMouse: TMenuItem;
    AvoidMouse: TMenuItem;
    N5: TMenuItem;
    EdEvolution: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure AddPlayer(kind: integer);
    procedure EdFrictionChange(Sender: TObject);
    procedure EdSideFrictionChange(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure EdDebugChange(Sender: TObject);
    procedure CopyParamsFromScreen;
    procedure CopyParamsFromPlayer;
    procedure UpdateGoals;
    procedure UpdateRealTimeParams;
    procedure Loadcircuit800x600BMP1Click(Sender: TObject);
    procedure SaveimagestofolderClick(Sender: TObject);
    procedure Pausesimulation1Click(Sender: TObject);
    procedure EdSecondsChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure EdSizeChange(Sender: TObject);
    procedure EdRadioChange(Sender: TObject);
    procedure BtnAddPlayerClick(Sender: TObject);
    procedure EdPlayerIdChange(Sender: TObject);
    procedure EdColorClick(Sender: TObject);
    procedure EdAutoRadioClick(Sender: TObject);
    procedure BtnSubPlayerClick(Sender: TObject);
    procedure EdCollisionsClick(Sender: TObject);
    procedure EdMinFuturesChange(Sender: TObject);
    procedure EdAI_LevelChange(Sender: TObject);
    procedure Addacircleofkarts1Click(Sender: TObject);
    procedure Addateamgoalforcollectingdrops1Click(Sender: TObject);
    procedure Addateamgoalforstoringcollecteddrops1Click(Sender: TObject);
    procedure AvoidOtherPlayersClick(Sender: TObject);
    procedure DeleteallTeamsGoals1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure menuPlayerParamsClick(Sender: TObject);
    procedure Runfast1Click(Sender: TObject);
    procedure Deleteallplayerspersonalgoals1Click(Sender: TObject);
    procedure Keepenergyhunger1Click(Sender: TObject);
    procedure PopupGoalParamPopup(Sender: TObject);
    procedure menuBetterSooerClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure menuIndividualClick(Sender: TObject);
    procedure menuCooperativeClick(Sender: TObject);
    procedure menuCompetitiveClick(Sender: TObject);
    procedure Keephealth1Click(Sender: TObject);
    procedure Suckenergyfromplayersinfrontofyou1Click(Sender: TObject);
    procedure FollowMouseClick(Sender: TObject);
    procedure EdPlayerIdEnter(Sender: TObject);
    procedure EdEvolutionClick(Sender: TObject);
  private
    ImgNumber: integer;
    MyTrack: TTrack2D;
    procedure ClearPlayers;
    function  GetMyTeam: TTeam;
    function  GetMyPlayer: TPlayer2D;
    procedure RunSimulation;
    procedure ReadGoalCoef(Sender: TObject);
  public
    property MyTeam: TTeam read GetMyTeam;
    property MyPlayer: TPlayer2D read GetMyPlayer;
  end;

var
  FormTest2D: TFormTest2D;

implementation

uses UPlayer, UUtils, UGoal,
     UGoal2dRaced, UGoal2dRotate, UGoal2dSweets, UGoal2dStorage,
     UGoal2DTeamAway, UGoalEnergy, UGoalHealth, UGoalBurnOut, UGoalMouse;


{$R *.dfm}


// *************************
// ** ADMINISTRATVE STUFF **
// *************************

// Form creation: add a track, a team and a player, so it is ready to run:
procedure TFormTest2D.FormCreate(Sender: TObject);
begin
  randomize;
  OpenPictureDialog.InitialDir:= ExtractFilePath(ParamStr(0));
  SaveDialog.InitialDir:= ExtractFilePath(ParamStr(0));
  ImgNumber:= 1;
  // Activate info panels:
  menuPlayerParamsClick(nil);
  // Create the track:
  MyTrack:= TTrack2D.create;
  // A sample track is already loaded, scan it for black pixels.
  MyTrack.Img:= ImgRoad;
  // Add a team to the track:
  MyTrack.AddTeam(TTeam.create);
  // Add a simple kart to the team:
  AddPlayer(2);
  // Initial draw:
  MyTrack.draw(true);
end;


// *********************
// **  ADD FORMATIONS **
// *********************

// Those formastions are for testing purpouse, the graphic interface doesn't
// allows you to set all the available options.

// Delete all players on the track:
procedure TFormTest2D.ClearPlayers;
begin
  while (MyTeam.PlayerCount > 0) do
    MyTeam.DelPlayer(MyPlayer, true);
  EdPlayerId.Clear;
end;

// Add a formation: circle with 36 karts
procedure TFormTest2D.Addacircleofkarts1Click(Sender: TObject);
const NKart: integer = 18;
var i: integer;
begin
  // Del all players:
  ClearPlayers;
  // Add a cricle of N karts at (400, 300) radius 100
  for i:= 0 to (NKart-1) do begin
    AddPlayer(0);
    TKart(MyPlayer).MaxPower:= 14;
    MyPlayer.Size:= 8;
    MyPlayer.PosX:= 400 + 90 * cos(i*(2*PI/NKart));
    MyPlayer.PosY:= 300 + 90 * sin(i*(2*PI/NKart));
    MyPlayer.Angle:= PI + i*(2*PI/NKart);
    MyPlayer.SetIniState;
  end;
  // Redraw:
  MyTrack.draw(true);
end;


// ********************
// ** PLAYER'S GOALS **
// ********************

procedure TFormTest2D.Deleteallplayerspersonalgoals1Click(Sender: TObject);
var
  OldId, i: integer;
begin
  OldId:= EdPlayerId.ItemIndex;
  for i:= 0 to EdPlayerId.Items.Count-1 do begin
    EdPlayerId.ItemIndex:= i;
    EdPlayerIdChange(Sender);
    while (MyPlayer.GoalCount>0) do
      MyPlayer.DelGoal(0);
  end;
  EdPlayerId.ItemIndex:= OldId;
  UpdateGoals;
end;


// ******************
// ** TEAM'S GOALS **
// ******************

procedure TFormTest2D.DeleteallTeamsGoals1Click(Sender: TObject);
begin
  while MyTeam.GoalCount>0 do
    MyTeam.DelGoal(0);
  UpdateGoals;
end;

procedure TFormTest2D.Runfast1Click(Sender: TObject);
begin
  MyTeam.AddGoal(TGoal2dRaced.create(1));
  UpdateGoals;
end;

procedure TFormTest2D.Addateamgoalforcollectingdrops1Click(
  Sender: TObject);
begin
  MyTeam.AddGoal(TGoal2dSweets.create(1));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugTeamGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.Addateamgoalforstoringcollecteddrops1Click(
  Sender: TObject);
var x, y: integer;
const Size: integer = 6;
begin
  // Find a place on the track for the store box:
  repeat
    x:= round((0.1+0.8*random) * MyTrack.Img.Width);
    y:= round((0.1+0.8*random) * MyTrack.Img.Height);
  until MyTrack.IsInsideTrack(x-Size,y-Size) and
        MyTrack.IsInsideTrack(x-Size,y+Size) and
        MyTrack.IsInsideTrack(x+Size,y-Size) and
        MyTrack.IsInsideTrack(x+Size,y+Size);
  MyTeam.AddGoal(TGoal2dStorage.create(1, x, y, Size, 500));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugTeamGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.AvoidOtherPlayersClick(Sender: TObject);
begin
  MyTeam.AddGoal(TGoal2dTeamAway.create(1, MyTeam));
  UpdateGoals;
end;

procedure TFormTest2D.FollowMouseClick(Sender: TObject);
begin
  MyTeam.AddGoal(TGoalMouse.create(0.1, TComponent(Sender).Tag=1));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugTeamGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.Suckenergyfromplayersinfrontofyou1Click(
  Sender: TObject);
begin
  MyTeam.AddGoal(TGoalBurnOut.create(1, MyTeam));
  UpdateGoals;
end;

procedure TFormTest2D.Keepenergyhunger1Click(Sender: TObject);
begin
  MyTeam.AddGoal(TGoalEnergy.create(1));
  UpdateGoals;
end;

procedure TFormTest2D.Keephealth1Click(Sender: TObject);
begin
  MyTeam.AddGoal(TGoalHealth.create(1));
  UpdateGoals;
end;


// ***************
// ** MAIN LOOP **
// ***************

procedure TFormTest2D.RunSimulation;
const
  // Each simulation tick correspond to 100 ms (0.1s).
  Sim_time: integer = 100;
  // Real CPU time I want the simulation to use:
  CPU_time: integer = 100;
begin
  Randomize;
  // Main loop is here, may be it should be moved inside TTrack and send a pointer
  // to this form so the track can update the input controls on the form.
  while StartBtn.Down do begin
    // Think about next frame and make all the moves:
    MyTrack.TakeAStep(CPU_time);
    // Update screen dials:
    UpdateRealTimeParams;
    // Refresh screen:
    Application.ProcessMessages;
    // Save image to folder?
    if Saveimagestofolder.Checked then begin
      ImgRoad.Picture.SaveToFile(SaveDialog.FileName+'_'+Format('%5.5d', [ImgNumber])+'.bmp');
      inc(ImgNumber);
    end;
  end;
end;


// ***********************************
// ** MANAGING PLAYERS ON THE TRACK **
// ***********************************

function TFormTest2D.GetMyTeam: TTeam;
begin
  result:= MyTrack.SelectedTeam;
end;

function TFormTest2D.GetMyPlayer: TPlayer2D;
begin
  result:= TPlayer2D(MyTeam.SelectedPlayer);
end;

// Pressed "Add" a new player to the team:
procedure TFormTest2D.BtnAddPlayerClick(Sender: TObject);
begin
  AddPlayer(TComponent(Sender).Tag);
  // Don't place it over the old one:
  if (MyTeam.PlayerCount>2) then begin
    MyPlayer.PosX:= MyPlayer.PosX + ( TPlayer2D(MyTeam.Player[MyTeam.PlayerCount-2]).PosX - TPlayer2D(MyTeam.Player[MyTeam.PlayerCount-3]).PosX);
    MyPlayer.PosY:= MyPlayer.PosY + ( TPlayer2D(MyTeam.Player[MyTeam.PlayerCount-2]).PosY - TPlayer2D(MyTeam.Player[MyTeam.PlayerCount-3]).PosY);
  end else begin
    MyPlayer.PosX:= MyPlayer.PosX + Cos(MyPlayer.Angle) * 30;
    MyPlayer.PosY:= MyPlayer.PosY + Sin(MyPlayer.Angle) * 30;
  end;
  // Redraw all:
  MyTrack.Draw(true);
end;

// Add a player to the team:
procedure TFormTest2D.AddPlayer(kind: integer);
var
  OldPlayer: TPlayer2D;
begin
  // Remember old selected player:
  OldPlayer:= MyPlayer;
  // Kind of player to create?
  if (Kind=0) then begin
    // Try to clone selected player:
    if MyPlayer is TRocket then
      Kind:= 2
    else
      Kind:= 1;
  end;
  // Add a new one of this kind:
  case Kind of
  1: MyTeam.AddPlayer( TKart.create(  330, 475, 0) );
  2: MyTeam.AddPlayer( TRocket.create(330, 450, -PI/2) );
  else
    exit;
  end;
  // Copy params from previously selected player:
  if Assigned(OldPlayer) then begin
    if (OldPlayer.ClassType = MyPlayer.ClassType) then begin
      MyPlayer.CopyFrom(OldPlayer);
    end else begin
      // CopyFrom on different types is not well implemente now!)
      //  TPlayer2D(MyPlayer).CopyFrom(OldPlayer);
      MyPlayer.PosX:=  OldPlayer.PosX;
      MyPlayer.PosY:=  OldPlayer.PosY;
      MyPlayer.Angle:= OldPlayer.Angle;
      // etc...
    end;
    // Clone goal strenghts:
    MyPlayer.CopyGoalsStrength(OldPlayer);
  end;
  // Evolution force strengths to be random:
  if MyTrack.Evolution then
    MyPlayer.RandomizeGoals;
  // Remember it as your initial state:
  MyPlayer.SetIniState;
  // Asign colors:
  // When Evolution is ON, color is defined by goals strength:
  if MyTrack.Evolution then begin
    MyPlayer.ColorUsingGoals;
    MyPlayer.DebugGoals:= true;
  end else begin
    if (MyTrack.PlayerCount = 1) then MyPlayer.Color:= clWhite;
    if (MyTrack.PlayerCount = 2) then MyPlayer.Color:= clYellow;
    if (MyTrack.PlayerCount = 3) then MyPlayer.Color:= RGBToColor(255,150,100); // Orange
    if (MyTrack.PlayerCount = 4) then MyPlayer.Color:= clRed;
    if (MyTrack.PlayerCount = 5) then MyPlayer.Color:= RGBToColor(150,150,150); // Grey
  end;
  // Add it to the combo box:
  EdPlayerId.Items.Add('Player #'+IntToStr(MyTrack.PlayerCount));
  EdPlayerId.ItemIndex:= EdPlayerId.Items.Count-1;
  // Refresh screen image and controls:
  CopyParamsFromPlayer;
  MyTrack.Draw(true);
end;

// Delete actual kart from the team:
procedure TFormTest2D.BtnSubPlayerClick(Sender: TObject);
begin
  if MyTrack.PlayerCount > 1 then begin
    // Delete kart:
    MyTeam.DelPlayer(MyPlayer, true);
    // Take from the ComboBox list:
    EdPlayerId.Items.Delete(EdPlayerId.Items.Count-1);
    EdPlayerId.ItemIndex:= 0;
    // Redraw all:
    EdPlayerIdChange(Sender);
    MyTrack.ClearTrack;
    MyTrack.Draw(true);
  end;
end;

// Selected player is changed, so update screen dials:
procedure TFormTest2D.EdPlayerIdChange(Sender: TObject);
begin
  MyTeam.SelectedPlayer:= MyTeam.Player[EdPlayerId.ItemIndex];
  CopyParamsFromPlayer;
end;

// Chose another color for the selected kart:
procedure TFormTest2D.EdColorClick(Sender: TObject);
begin
  ColorDialog.Color:= EdColor.Color;
  if ColorDialog.Execute then begin
    EdColor.Color:= ColorDialog.Color;
    MyPlayer.Color:= EdColor.Color;
    MyTrack.Draw(true);
  end;
end;



// ***********************
// ** MENUS AND BUTTONS **
// ***********************

// RUN is pressed
procedure TFormTest2D.StartBtnClick(Sender: TObject);
begin
  // Activate the main loop:
  RunSimulation;
end;

// PAUSE simulation (from menu, button works auto):
procedure TFormTest2D.Pausesimulation1Click(Sender: TObject);
begin
  PauseBtn.Down:= true;
end;

// RESET pressed:
procedure TFormTest2D.ResetBtnClick(Sender: TObject);
var
  t: integer;
begin
  ImgNumber:= 1;
  for t:= 0 to MyTrack.TeamCount-1 do
    MyTrack.Team[t].ResetState;
  CopyParamsFromScreen;
  MyTrack.Draw(true);
end;

// Loading a new image for the track form menu:
procedure TFormTest2D.Loadcircuit800x600BMP1Click(Sender: TObject);
var
  Ext: string;
  //TmpPicture: TPicture;
begin
  if OpenPictureDialog.Execute then begin
    Ext:= UpperCase(ExtractFileExt(OpenPictureDialog.FileName));
    // BMPs and PNGs load in a different way:
    if (Ext='.PNG') then begin
      // Neither method worked for me (on D7) so droping PNG support!
      //
      //TmpPicture:= TPicture.create;
      //TmpPicture.Graphic:= TPNGObject.create;
      //TPNGObject(TmpPicture.Graphic).LoadFromFile(OpenPictureDialog.FileName);
      //ImgRoad.Picture.Assign(TmpPicture);
      //
      //ImgRoad.Picture.Assign(TPicture.create);
      //ImgRoad.Picture.Graphic:= TPNGObject.create;
      //TPNGObject(ImgRoad.Picture.Graphic).LoadFromFile(OpenPictureDialog.FileName);
    end else if (Ext='.BMP') then begin
      ImgRoad.Picture.LoadFromFile(OpenPictureDialog.FileName);
    end;
    // Scan new track:
    MyTrack.Img:= ImgRoad;
    // Repaint karts on it:
    MyTrack.Draw(true);
  end;
end;

// Selecting a folder (and file name) where to save images:
procedure TFormTest2D.SaveimagestofolderClick(Sender: TObject);
begin
  // Switch on/off image recording:
  if SaveImagesToFolder.Checked then begin
    if not SaveDialog.Execute then
      SaveImagesToFolder.Checked:= false;
  end;
end;


// ***********************
// ** SIMULATION PARAMS **
// ***********************

// Transfer screen params to the actual player and track:
procedure TFormTest2D.CopyParamsFromScreen;
begin
  // Player params:
  EdSizeChange(nil);
  EdRadioChange(nil);
  EdAutoRadioClick(nil);
  // Track params.
  EdFrictionChange(nil);
  EdSideFrictionChange(nil);
  // Think params.
  EdSecondsChange(nil);
  EdMinFuturesChange(nil);
  EdCollisionsClick(nil);
  EdAI_LevelChange(nil);
  // Debug params.
  EdDebugChange(nil);
end;

// Transfer params from the actual player and track to screen:
procedure TFormTest2D.CopyParamsFromPlayer;
begin
  EdSeconds.Position:=      round(MyTrack.FutureMSeconds/1000);
  EdMinFutures.Position:=   MyTrack.MinFutures;
  EdSize.Position:=         round(MyPlayer.Size);
  EdFriction.Position:=     round(MyTrack.Friction*1000);
  EdSideFriction.Position:= round(MyTrack.SideFriction*100);
  EdColor.Color:=           MyPlayer.Color;
  EdRadio.Max:=             MyPlayer.MaxGridSize;
  EdRadio.Min:=             MyPlayer.MinGridSize;
  EdAutoRadio.Checked:=     MyPlayer.AutoGridSize;
  EdAI_Level.ItemIndex:=    MyPlayer.AI_Level - 1;
  // Update goals panel:
  UpdateGoals;
  // Read params that change during simulation:
  UpdateRealTimeParams;
  // Debug menu:
  MenuDebugTraces.Checked:=  MyPlayer.DebugTraces;
  MenuDebugOptions.Checked:= MyPlayer.DebugOptions;
  MenuDebugGoals.Checked:=   MyPlayer.DebugGoals;
  MenuDebugLevels.Checked:=  MyPlayer.DebugLevels;
  // Update labels:
  CopyParamsFromScreen;
end;


// *****************
// ** GOALS PANEL **
// *****************

// Update goals panel:
procedure TFormTest2D.UpdateGoals;
var
  i, h: integer;
const
  Sep: integer = 34;

  procedure AddGoal(t: integer; Goal: TGoal);
  var Lb: TLabel;
      Tb: TTrackBar;
  begin
    // Title of the goal:
    Lb:= TLabel.create(EdGoals);
    Lb.Parent:= EdGoals;
    Lb.PopupMenu:= PopupGoalParam;
    Lb.Tag:= t;
    Lb.Left:= 10;
    Lb.Top:= h;
    if (t<0) then begin
      Lb.Caption:= 'T: '+Goal.DisplayName;
      Lb.Hint:= 'Team goal';
    end else begin
      Lb.Caption:= 'P: '+Goal.DisplayName;
      Lb.Hint:= 'Player goal';
    end;
    // Slider to change strength of the goal:
    Tb:= TTrackBar.Create(EdGoals);
    Tb.Parent:= EdGoals;
    Tb.PopupMenu:= PopupGoalParam;
    Tb.Tag:= t;
    Tb.TickStyle:= tsNone;
    Tb.ThumbLength:= 9;
    Tb.Left:= 10;
    Tb.Top:= h + 14;
    Tb.Width:= EdGoals.Width - TB.Left - 10;
    Tb.Height:= 17;
    Tb.Max:= 100;
    Tb.Min:=   0;
    Tb.Frequency:= 10;
    Tb.Position:= round(100*Goal.Strength/Goal.MaxStrength);
    Tb.OnChange:= ReadGoalCoef;
    // Actual value of the goal (coef = strength):
    Lb:= TLabel.create(EdGoals);
    Lb.Parent:= EdGoals;
    Lb.PopupMenu:= PopupGoalParam;
    Lb.Tag:= t;
    Lb.Alignment:= taRightJustify;
    Lb.Left:=  Tb.Left;
    Lb.Width:= Tb.Width;
    Lb.Top:= h;
    Lb.Caption:= Format('%3.2f', [Goal.Strength]);
    h:= h + Sep;
    EdGoals.Height:= h + 10;
  end;

begin
  // Clean the list:
  while EdGoals.ComponentCount>0 do
    EdGoals.Components[0].Free;
  h:= 24;
  // Add player's goals:
  for i:= 0 to MyPlayer.GoalCount-1 do
    AddGoal(+(i+1), MyPlayer.Goal[i]);
  // Add team's goals:
  for i:= 0 to MyTeam.GoalCount-1 do
    AddGoal(-(i+1), MyTeam.Goal[i]);
end;

// User moved the goal coef, update it:
procedure TFormTest2D.ReadGoalCoef(Sender: TObject);
var
  t, n, i: integer;
  Team: boolean;
  Panel: TComponent;
  Goal: TGoal;
begin
  // Team or Player goal? Witch number?
  t:= TComponent(Sender).Tag;
  Team:= (t<0);
  n:= abs(t)-1;
  if team then
    Goal:= MyTeam.Goal[n]
  else
    Goal:= MyPlayer.Goal[n];
  // Update goal coef:
  Goal.Strength:= TTrackBar(Sender).Position/100 * Goal.MaxStrength;
  // Update screen label:
  Panel:= TControl(Sender).Parent;
  for i:= 0 to Panel.ComponentCount-1 do begin
    if (Panel.Components[i] is TLabel) and
       (Panel.Components[i].Tag = t) and
       (TLabel(Panel.Components[i]).Alignment = taRightJustify) then
      TLabel(Panel.Components[i]).Caption:= Format('%3.2f', [Goal.Strength]);
  end;
end;

procedure TFormTest2D.PopupGoalParamPopup(Sender: TObject);
var
  Pos: TPoint;
  Ctr: TControl;
  t, n: integer;
  Team: boolean;
  Goal: TGoal;
begin
  // Sender.Tag is the player/team goal index (1=first player goal, -1=first team goal):
  Pos:= EdGoals.ScreenToClient(Mouse.CursorPos);
  Ctr:= EdGoals.ControlAtPos(Pos, false, true);
  if not Assigned(Ctr) then
    exit;
  t:= TComponent(Ctr).Tag;
  n:= abs(t)-1;
  Team:= (t<0);
  if Team then Goal:= MyTeam.Goal[n]
  else         Goal:= MyPlayer.Goal[n];
  //
  menuBetterSooner.tag:= t;
  menuBetterSooner.Checked:= Goal.SoonerIsBetter;
  // Goal type (cooperative, competitive...):
  menuIndividual.Tag:= t;
  menuIndividual.Checked:= (Goal.GoalType = gtIndividualist);
  menuIndividual.Enabled:= (t<0);
  menuCooperative.Tag:= t;
  menuCooperative.Checked:= (Goal.GoalType = gtCooperative);
  menuCooperative.Enabled:= (t<0);
  menuCompetitive.Tag:= t;
  menuCompetitive.Checked:= (Goal.GoalType = gtCompetitive);
  menuCompetitive.Enabled:= (t<0);
end;

procedure TFormTest2D.menuBetterSooerClick(Sender: TObject);
var
  t, n: integer;
  Team: boolean;
  Goal: TGoal;
begin
  // Sender.Tag is the player/team goal index (1=first player goal, -1=first team goal):
  t:= TComponent(Sender).Tag;
  n:= abs(t)-1;
  Team:= (t<0);
  if Team then Goal:= MyTeam.Goal[n]
  else         Goal:= MyPlayer.Goal[n];
  //
  Goal.SoonerIsBetter:= menuBetterSooner.Checked;
end;

procedure TFormTest2D.menuIndividualClick(Sender: TObject);
var
  t, n: integer;
  Team: boolean;
  Goal: TGoal;
begin
  // Sender.Tag is the player/team goal index (1=first player goal, -1=first team goal):
  t:= TComponent(Sender).Tag;
  n:= abs(t)-1;
  Team:= (t<0);
  if Team then Goal:= MyTeam.Goal[n]
  else         Goal:= MyPlayer.Goal[n];
  //
  Goal.GoalType:= gtIndividualist;
end;

procedure TFormTest2D.menuCooperativeClick(Sender: TObject);
var
  t, n: integer;
  Team: boolean;
  Goal: TGoal;
begin
  // Sender.Tag is the player/team goal index (1=first player goal, -1=first team goal):
  t:= TComponent(Sender).Tag;
  n:= abs(t)-1;
  Team:= (t<0);
  if Team then Goal:= MyTeam.Goal[n]
  else         Goal:= MyPlayer.Goal[n];
  //
  Goal.GoalType:= gtCooperative;
end;

procedure TFormTest2D.menuCompetitiveClick(Sender: TObject);
var
  t, n: integer;
  Team: boolean;
  Goal: TGoal;
begin
  // Sender.Tag is the player/team goal index (1=first player goal, -1=first team goal):
  t:= TComponent(Sender).Tag;
  n:= abs(t)-1;
  Team:= (t<0);
  if Team then Goal:= MyTeam.Goal[n]
  else         Goal:= MyPlayer.Goal[n];
  //
  Goal.GoalType:= gtCompetitive;
end;




// Only some params do change during simulation, only refresh those:
procedure TFormTest2D.UpdateRealTimeParams;
begin
  EdRadio.Position:= round(MyPlayer.GridSize);
end;


// ************************
// ** CHANGING ONE PARAM **
// ************************

procedure TFormTest2D.EdMinFuturesChange(Sender: TObject);
begin
  MyTrack.MinFutures:= EdMinFutures.Position;
  LbMinFutures.Caption:= IntToStr(EdMinFutures.Position);
end;

procedure TFormTest2D.EdAutoRadioClick(Sender: TObject);
begin
  MyPlayer.AutoGridSize:= EdAutoRadio.Checked;
end;

procedure TFormTest2D.EdFrictionChange(Sender: TObject);
begin
  LbFriction.Caption:= FloatToStr(EdFriction.Position/1000);
  MyTrack.Friction:= EdFriction.Position/1000;
end;

procedure TFormTest2D.EdSideFrictionChange(Sender: TObject);
begin
  LbSideFriction.Caption:=  FloatToStr(EdSideFriction.Position/100);
  MyTrack.SideFriction:= EdSideFriction.Position/100;
end;

// What to debug?
procedure TFormTest2D.EdDebugChange(Sender: TObject);
begin
  MyPlayer.DebugTraces:=  MenuDebugTraces.Checked;
  MyPlayer.DebugOptions:= MenuDebugOptions.Checked;
  MyPlayer.DebugLevels:=  MenuDebugLevels.Checked;
  MyPlayer.DebugGoals:=   MenuDebugGoals.Checked;
  MyTeam.DebugGoals:=     MenuDebugTeamGoals.Checked;
  MyTrack.Draw(true);
end;

procedure TFormTest2D.EdSizeChange(Sender: TObject);
begin
  MyPlayer.Size:= EdSize.Position;
  LbSize.Caption:= IntToStr(EdSize.Position)+ 'px';
  MyTrack.Draw(true);
end;

procedure TFormTest2D.EdRadioChange(Sender: TObject);
begin
  MyPlayer.GridSize:= EdRadio.Position;
  LbRadio.Caption:= IntToStr(EdRadio.Position)+ 'px';
end;

procedure TFormTest2D.EdSecondsChange(Sender: TObject);
begin
  MyTrack.FutureMSeconds:= EdSeconds.Position * 1000;
  LbSeconds.Caption:= IntToStr(EdSeconds.Position)+' s.'
end;

procedure TFormTest2D.EdCollisionsClick(Sender: TObject);
begin
  MyTrack.PlayersCollide:= EdCollisions.Checked;
end;

procedure TFormTest2D.EdAI_LevelChange(Sender: TObject);
begin
  MyPlayer.AI_Level:= EdAI_Level.ItemIndex + 1;
end;

// *******************************
// ** MOVING THE PLAYER BY HAND **
// *******************************

procedure TFormTest2D.SpeedButton1Click(Sender: TObject);
begin
  MyPlayer.HandMove(-5, 0, 0);
  if not StartBtn.Down then MyPlayer.SetIniState;
end;

procedure TFormTest2D.SpeedButton3Click(Sender: TObject);
begin
  MyPlayer.HandMove(5, 0, 0);
  if not StartBtn.Down then MyPlayer.SetIniState;
end;

procedure TFormTest2D.SpeedButton2Click(Sender: TObject);
begin
  MyPlayer.HandMove(0, -5, 0);
  if not StartBtn.Down then MyPlayer.SetIniState;
end;

procedure TFormTest2D.SpeedButton4Click(Sender: TObject);
begin
  MyPlayer.HandMove(0, 5, 0);
  if not StartBtn.Down then MyPlayer.SetIniState;
end;

procedure TFormTest2D.SpeedButton5Click(Sender: TObject);
begin
  MyPlayer.HandMove(0, 0, +PI/12);
  if not StartBtn.Down then MyPlayer.SetIniState;
end;

procedure TFormTest2D.SpeedButton6Click(Sender: TObject);
begin
  MyPlayer.HandMove(0, 0, -PI/12);
  if not StartBtn.Down then MyPlayer.SetIniState;
end;

// Refill energy of the player:
procedure TFormTest2D.SpeedButton8Click(Sender: TObject);
begin
  if TComponent(Sender).Tag=0 then
    MyPlayer.Energy:= 10 //MyPlayer.Energy + 10
  else
    MyPlayer.Health:= 10; //MyPlayer.Health + 10;
  MyTrack.draw(true);
end;

// Activate panels:
procedure TFormTest2D.menuPlayerParamsClick(Sender: TObject);
begin
  EdAIParams.Visible:=     menuBasicAIparams.Checked;
  EdChoosePlayer.Visible:= menuChoosePlayer.Checked;
  EdPlayerParams.Visible:= menuPlayerParams.Checked;
  EdGoals.Visible:=        menuGoals.Checked;
  EdHandMove.Visible:=     menuHandMove.Checked;
  EdTrackParams.Visible:=  menuTrackParams.Checked;
end;

procedure TFormTest2D.FormResize(Sender: TObject);
begin
  // Keep image ratio at 800x600
  ImgRoad.Height:= Min(PanelImg.ClientHeight, round(PanelImg.ClientWidth/800*600));
  ImgRoad.Width := Min(PanelImg.ClientWidth,  round(PanelImg.ClientHeight*800/600));
end;


procedure TFormTest2D.EdPlayerIdEnter(Sender: TObject);
var
  i, Id: integer;
  ActualPlayer: TPlayer;
begin
  // Reload player list from track records:
  ActualPlayer:= MyTrack.SelectedTeam.SelectedPlayer;
  Id:= 0;
  EdPlayerId.Clear;
  MyTrack.RefreshPlayerList;
  for i:= 0 to MyTrack.SelectedTeam.PlayerCount-1 do begin
    EdPlayerId.Items.Add('Player #'+IntToStr(i));
    // Must I left this one selected at the end?
    if (MyTrack.SelectedTeam.Player[i] = ActualPlayer) then
      Id:= i;
  end;
  // Select the "old selected player" on the new list:
  EdPlayerId.ItemIndex:= Id;
end;

procedure TFormTest2D.EdEvolutionClick(Sender: TObject);
begin
  MyTrack.Evolution:= EdEvolution.Checked;
end;

end.
